/* YOODA : Yet another Object Oriented Database
   Copyright (C) 1994  Eric Abecassis

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the Free
Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */


#pragma interface

struct hem_ptr_bitfield {
  u_int level12 : 2 ;
  u_int level11 : 2 ;
  u_int level10 : 2 ;
  u_int level9 : 2 ;
  u_int level8 : 2 ;  
  u_int level7 : 2 ;
  u_int level6 : 2 ;
  u_int level5 : 2 ;
  u_int level0 : 8 ;
  u_int level4 : 2 ;  
  u_int level3 : 2 ;
  u_int level2 : 2 ;
  u_int level1 : 2 ;
} ;


class SetIdent {
  private :
  union {
    void* _adr ;
    hem_ptr_bitfield level ;
  } ;

  public :
  SetIdent(void* ptr) { this->_adr = ptr ; }
  void* adr() { return _adr ; }
  int operator==(const SetIdent& p) const { return this->_adr == p._adr ; }
  int getRootInd() const { return level.level0 ; }
  int getNodeInd(int lev) const {
    if (lev == 1) {
      return level.level1 ;
    } else if (lev == 2) {
      return level.level2 ;
    } else if (lev == 3) {
      return level.level3 ;
    } else if (lev == 4) {
      return level.level4 ;
    } else if (lev == 5) {
      return level.level5 ;
    } else if (lev == 6) {
      return level.level6 ;
    } else if (lev == 7) {
      return level.level7 ;
    } else if (lev == 8) {
      return level.level8 ;
    } else if (lev == 9) {
      return level.level9 ;
    } else if (lev == 10) {
      return level.level10 ;
    } else if (lev == 11) {
      return level.level11 ;
    } else if (lev == 12) {
      return level.level11 ;
    } else return level.level0 ;
  } 
} ;

